<template>
  <div class="box">
    <view-bar>Osoba</view-bar>
    <list-body class="top-list" :status="element_status">
      <h3>{{ name }} {{ surname }}</h3>
      <span
        ><tooltip>Adres email</tooltip><font-awesome-icon :icon="icons.faAt" />
        {{ email }}</span
      >
      <span
        ><tooltip>Uprawnienia</tooltip
        ><font-awesome-icon :icon="icons.faKey" /> {{ perm }}</span
      >
    </list-body>
    <h2>Przedmioty przyjęte przez osobę</h2>
    <list-body :status="list_status" :length="items.length">
      <item-list-item v-for="item in items" :key="item.id" v-bind="item" />
    </list-body>
  </div>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";
import ViewBar from "@/components/ViewBar.vue";
import GenericEdit from "@/views/edit-views/GenericEdit";
import { ItemData, LocationData, UserData } from "@/interfaces";
import { NApi, QueryFilter } from "@/interfaces/connector";
import ListBody from "@/components/list/ListBody.vue";
import ItemListItem from "@/components/list/custom/ItemListItem.vue";
import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { faAt, faKey } from "@fortawesome/free-solid-svg-icons";
import Tooltip from "@/components/utilities/Tooltip.vue";

@Options({
  props: {
    id: Number,
  },
  components: {
    ViewBar,
    ListBody,
    ItemListItem,
    FontAwesomeIcon,
    Tooltip,
  },
})
export default class EditUser
  extends GenericEdit<ItemData, UserData>
  implements UserData {
  public id!: number;

  LIST_API_CALL = async () =>
    await NApi.getItems(
      new QueryFilter().is("hold_by", "user_id", parseInt(String(this.id)))
    );
  ELEMENT_API_CALL = async () => await NApi.getUser(parseInt(String(this.id)));

  public name = "";
  public surname = "";
  public email = "";
  public perm = "";

  public icons = {
    faAt,
    faKey,
  };

  public items: ItemData[] = [];

  set_list(list: ItemData[]) {
    this.items = list;
  }

  set_element(data: UserData) {
    this.name = data.name;
    this.surname = data.surname;
    this.email = data.email;
    this.perm = data.perm;
  }
}
</script>

<style lang="scss" scoped>
@import "@/styles/globals";

.box {
  height: 100%;
  display: grid;

  grid-template-rows: auto auto auto 1fr;

  h3,
  span {
    position: relative;
    display: block;
    padding: 0px;
    margin: 0px;
    text-align: left;

    color: $black_text;
  }

  h3 {
    font-weight: bold;
  }

  .top-list {
    padding-top: 40px;
  }
}
</style>
